#include <stdio.h>
#include <readline/readline.h>
#include <readline/history.h>
#include <sys/param.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <curses.h>

#include "command.h"
#include "climain.h"
#include "config.h"
#include "build_config.h"
#include "filter.h"
#include "if.h"
#include "shared.h"
#include "ip.h"
#include "list.h"
#include "cdp.h"
#include "lac_cli.h"
#include "../swctl/lac_user.h"

//================================================command.c==================================================================================
void cmd_lac_port(FILE *out, char **argv)
{
	show_ports(sock_fd);
}
void cmd_lac_agg(FILE *out, char **argv)
{
	show_aggregators(sock_fd);
}
void cmd_lac_system(FILE *out, char **argv)
{
	show_system(sock_fd);
}
//================================================END command.c==================================================================================
//================================================config.c =============================================================================
char *if_name_agg(char *arg) ;
int valid_lac_agg(char *arg, char lookahead) 
{
	return 1;
}
void send_ioctl(int sock, struct net_switch_ioctl_arg *user_arg)
{
	if(ioctl(sock_fd, SIOCSWCFG, user_arg)!=0)
	{
		perror("command failed\n");
	}
}
/*
void cmd_int_agg(FILE *out, char **argv) 
{
	char *arg = *argv;
	struct net_switch_ioctl_arg user_arg;

	user_arg.if_name=(char*)malloc(IFNAMSIZ*sizeof(char));
	memset(user_arg.if_name,0,IFNAMSIZ*sizeof(char));
	strncpy(user_arg.if_name,if_name_agg(arg),(IFNAMSIZ-1)*sizeof(char));

	user_arg.cmd=LACTL_ADD_AGG;

	if(!ioctl(sock_fd, SIOCSWCFG, &user_arg))
	{
		;
	}
	else
	{
		perror("command failed::");
		return ;
	}


	struct net_switch_ioctl_arg ioctl_arg;
	ioctl_arg.cmd = SWCFG_ADDIF;
	ioctl_arg.if_name = if_name_agg(arg);
	do {
		if(!ioctl(sock_fd, SIOCSWCFG, &ioctl_arg))
			break;
		if(errno == ENODEV) {
			fprintf(out, "Command rejected: device %s does not exist\n",
					ioctl_arg.if_name);
			return;
		}
	} while(0);

	cmd_root = &command_root_config_if_agg;
	strcpy(sel_eth, ioctl_arg.if_name);
	// Enable CDP on this interface 
	//cmd_cdp_if_enable(out, argv); ADI or not
}
*/
void cmd_no_int_agg(FILE *out, char **argv) 
{
	char *arg = argv[1];// argv[0] is "no" 
	struct net_switch_ioctl_arg user_arg;

	user_arg.if_name=(char*)malloc(IFNAMSIZ*sizeof(char));
	memset(user_arg.if_name,0,IFNAMSIZ*sizeof(char));
	strncpy(user_arg.if_name,if_name_agg(arg),(IFNAMSIZ-1)*sizeof(char));

	user_arg.cmd=LACTL_REM_AGG;
	send_ioctl(sock_fd, &user_arg);


	struct net_switch_ioctl_arg ioctl_arg;
	ioctl_arg.cmd = SWCFG_DELIF;
	ioctl_arg.if_name = if_name_agg(arg);
	send_ioctl(sock_fd,  &ioctl_arg);

}

//=================================================ADI============================================================================

int valid_lac_priority(char *arg, char lookahead)
{
	int no;

	sscanf(arg, "%d", &no);
	if (no < 0 || no > 65535)
	{
		return 0;
	}
	return 1;
}

void cmd_lac_priority_max_delay(FILE *out, char **argv,int command) 
{
	char *arg = argv[0];
	unsigned int value;
	lac_cfg_cmd_t cfg_cmd;
	struct net_switch_ioctl_arg user_arg;
	value = atoi(arg);
	user_arg.cmd= command;
	cfg_cmd.value = value;
	user_arg.lac_user_cmd.param = (void *)&cfg_cmd;
	user_arg.if_name=DEFAULT_AGG_NAME;


	send_ioctl(sock_fd, &user_arg);

}
void cmd_lac_priority(FILE *out, char **argv)
{
	cmd_lac_priority_max_delay(out,argv,LACTL_SET_SYS_PRIO);
}
void cmd_lac_max_delay(FILE *out, char **argv)
{
	cmd_lac_priority_max_delay(out,argv,LACTL_SET_SYS_MAX_DELAY);
}
//=================================================config.c END============================================================================

//==========================================config_if.c=====================================================================================
int valid_lac_priority(char *arg, char lookahead);
port_params_t get_port_by_name(int sock,char *name);
/*
void cmd_lac_general_command(FILE *out, char **argv,int command) 
{
	struct net_switch_ioctl_arg user_arg;
	lac_cfg_cmd_t cfg_cmd;
	port_params_t port_params;

	user_arg.cmd= command;
	if(command==LACTL_ADD_IF || command==LACTL_DEL_IF)
	{
		cfg_cmd.port.port_name =sel_eth ;
	}
	else
	{
		port_params=get_port_by_name(sock_fd,sel_eth);
		if(port_params.port_no<1)
		{
			printf("Port not in Aggregation system yet. First add it to the system.\n");
			return;
		}
		cfg_cmd.port.port_no = port_params.port_no;
	}
	
	user_arg.lac_user_cmd.param = (void *)&cfg_cmd;
	user_arg.if_name=DEFAULT_AGG_NAME;

	send_ioctl(sock_fd,  &user_arg);

}
*/
void cmd_lac_add_port(FILE *out, char **argv) 
{
	cmd_lac_general_command(out,argv,LACTL_ADD_IF);
}
void cmd_nolac_add_port(FILE *out, char **argv) 
{
	cmd_lac_general_command(out,argv,LACTL_DEL_IF);
}
void cmd_lac_enable(FILE *out, char **argv) 
{
	cmd_lac_general_command(out,argv,LACTL_SET_AGG_STATE_ENABLED);
}
void cmd_lac_disable(FILE *out, char **argv) 
{
	cmd_lac_general_command(out,argv,LACTL_SET_AGG_STATE_DISABLED);
}
void cmd_lac_mode_active(FILE *out, char **argv) 
{
	cmd_lac_general_command(out,argv,LACTL_SET_MODE_ACTIVE);
}
void cmd_lac_mode_pasive(FILE *out, char **argv) 
{
	cmd_lac_general_command(out,argv,LACTL_SET_MODE_PASSIVE);
}
/*
void cmd_lac_value_general(FILE *out, char **argv,int command) 
{
	char *arg = argv[0];
	unsigned int value;
	lac_cfg_cmd_t cfg_cmd;
	struct net_switch_ioctl_arg user_arg;
	port_params_t port_params;
	port_params=get_port_by_name(sock_fd,sel_eth);

	if(port_params.port_no<1)
	{
		printf("Port not in Aggregation system yet. First add it to the system.\n");
		return;
	}
	value = atoi(arg);
	user_arg.cmd= command;
	cfg_cmd.value = value;
	cfg_cmd.port.port_no = port_params.port_no;
	user_arg.lac_user_cmd.param = (void *)&cfg_cmd;

	user_arg.if_name=DEFAULT_AGG_NAME;

	send_ioctl(sock_fd,  &user_arg);

}
*/
void cmd_lac_key(FILE *out, char **argv) 
{
	cmd_lac_value_general(out,argv,LACTL_SET_ADMIN_KEY);
}
void cmd_lac_priority_if(FILE *out, char **argv) 
{
	cmd_lac_value_general(out,argv,LACTL_SET_PORT_PRIO);
}
void cmd_lac_timeout_short(FILE *out, char **argv)
{
	cmd_lac_general_command(out,argv,LACTL_SET_SHORT_TIMEOUT);
}
void cmd_lac_timeout_long(FILE *out, char **argv)
{
	cmd_lac_general_command(out,argv,LACTL_SET_LONG_TIMEOUT);
}
//==========================================END config_if.c=====================================================================================















