extern void cmd_lac_port(FILE *out, char **argv);
extern void cmd_lac_agg(FILE *out, char **argv);
extern void cmd_lac_system(FILE *out, char **argv);
char *if_name_agg(char *arg) ;
extern int valid_lac_agg(char *arg, char lookahead); 
extern void send_ioctl(int sock, struct net_switch_ioctl_arg *user_arg);
extern void cmd_int_agg(FILE *out, char **argv) ;
extern void cmd_no_int_agg(FILE *out, char **argv) ;
extern int valid_lac_priority(char *arg, char lookahead);
extern void cmd_lac_priority_max_delay(FILE *out, char **argv,int command) ;
extern void cmd_lac_priority(FILE *out, char **argv);
extern void cmd_lac_max_delay(FILE *out, char **argv);
extern int valid_lac_priority(char *arg, char lookahead);
extern port_params_t get_port_by_name(int sock,char *name);
extern void cmd_lac_general_command(FILE *out, char **argv,int command) ;
extern void cmd_lac_add_port(FILE *out, char **argv) ;
extern void cmd_nolac_add_port(FILE *out, char **argv) ;
extern void cmd_lac_enable(FILE *out, char **argv) ;
extern void cmd_lac_disable(FILE *out, char **argv) ;
extern void cmd_lac_mode_active(FILE *out, char **argv) ;
extern void cmd_lac_mode_pasive(FILE *out, char **argv) ;
extern void cmd_lac_value_general(FILE *out, char **argv,int command) ;
extern void cmd_lac_key(FILE *out, char **argv) ;
extern void cmd_lac_priority_if(FILE *out, char **argv) ;
extern void cmd_lac_timeout_short(FILE *out, char **argv);
extern void cmd_lac_timeout_long(FILE *out, char **argv);











//================================================command.c ==================================================================================
sw_command_t sh_lac[] = {
	{"port",				2,	NULL,		cmd_lac_port,		RUN,			"ADI Show ports' parameters",			NULL},
	{"agg",					2,	NULL,		cmd_lac_agg,		RUN,			"ADI Show aggregators",					NULL},
	{"system",				2,	NULL,		cmd_lac_system,		RUN,			"ADI Show system parameters",			NULL},
	{NULL,					0,	NULL,		NULL,			0,			NULL,											NULL}
};
//================================================END command.c ==================================================================================

//=================================================config.c ============================================================================
sw_command_t sh_lac_priority[] = {
	{"<1 - 65535>",			2,	valid_lac_priority,		cmd_lac_priority,	RUN,		"ADI Priority value",					NULL},
	{NULL,					0,	NULL,		NULL,			0,			NULL,												NULL}
};
sw_command_t sh_lac_max_delay[] = {
	{"<1 - 65535>",			2,	valid_lac_priority,		cmd_lac_max_delay,	RUN,		"ADI Max delay value",					NULL},
	{NULL,					0,	NULL,		NULL,			0,			NULL,												NULL}
};
sw_command_t sh_lac_config[] = {
	{"priority",			2,	NULL,		NULL,			0,			"ADI Set system priority <1 - 65535>",				sh_lac_priority},
	{"max_delay",			2,	NULL,		NULL,			0,			"ADI Set system collector max delay <1 - 65535>",	sh_lac_max_delay},
	{NULL,					0,	NULL,		NULL,			0,			NULL,												NULL}
};
sw_command_t sh_nolac[] = {
	{NULL,					0,	NULL,		NULL,			0,			NULL,												NULL}
};
sw_command_t sh_no_int_agg[] = {
	{"WORD",				15,	valid_lac_agg,	cmd_no_int_agg,		RUN,		"ADI Aggregator name",					NULL},
	{NULL,					0,	NULL,		NULL,				0,			NULL,											NULL}
};

sw_command_t sh_int_agg[] = {
	{"WORD",				15,	valid_lac_agg,	cmd_int_agg,		RUN,		"ADI Aggregator name",					NULL},
	{NULL,					0,	NULL,		NULL,				0,			NULL,											NULL}
};
//=================================================config.c END============================================================================
//==========================================config_if.c======================================================================================
sw_command_t sh_lac_aggregation[] = {
	{"enabled",				2,	NULL,		cmd_lac_enable,	RUN,		"ADI Enable aggregation",						NULL},
	{"disabled",			2,	NULL,		cmd_lac_disable,	RUN,	"ADI Disable aggregation",						NULL},
	{NULL,					0,	NULL,		NULL,			0,			NULL,												NULL}
};
sw_command_t sh_lac_mode[] = {
	{"active",				2,	NULL,		cmd_lac_mode_active,	RUN,		"ADI Aggregation mode active",						NULL},
	{"pasive",				2,	NULL,		cmd_lac_mode_pasive,	RUN,		"ADI Aggregation mode pasive",					NULL},
	{NULL,					0,	NULL,		NULL,			0,			NULL,												NULL}
};

sw_command_t sh_lac_admin_key[] = {
	{"<1 - 65535>",			2,	valid_lac_priority,		cmd_lac_key,	RUN,		"ADI Key value",					NULL},
	{NULL,					0,	NULL,		NULL,			0,			NULL,												NULL}
};
sw_command_t sh_lac_priority_if[] = {
	{"<1 - 65535>",			2,	valid_lac_priority,		cmd_lac_priority_if,	RUN,	"ADI Priority value",					NULL},
	{NULL,					0,	NULL,		NULL,			0,			NULL,												NULL}
};
sw_command_t sh_lac_timeout[] = {
	{"short",				2,	NULL,		cmd_lac_timeout_short,	RUN,		"ADI Short timeout",					NULL},
	{"long",				2,	NULL,		cmd_lac_timeout_long,	RUN,		"ADI Long timeout",					NULL},
	{NULL,					0,	NULL,		NULL,			0,			NULL,												NULL}
};
sw_command_t sh_lac_if[] = {
	{"add_port",			2,	NULL,		cmd_lac_add_port,	RUN,	"ADI Add interface to the Link Aggregation system",	NULL},
	{"aggregation",			2,	NULL,		NULL,				RUN,			"ADI Set port aggregation",					sh_lac_aggregation},
	{"mode",				2,	NULL,		NULL,				RUN,			"ADI Set port lacp mode",					sh_lac_mode},
	{"key",					2,	NULL,		NULL,			0,			"ADI Set port admin key <1 - 65535>",				sh_lac_admin_key},
	{"port_prio",			2,	NULL,		NULL,			0,			"ADI Set port priority <1 - 65535>",				sh_lac_priority_if},
	{"timeout",				2,	NULL,		NULL,			0,			"ADI Set port timeout <long/short>",				sh_lac_timeout},
	{NULL,					0,	NULL,		NULL,			0,			NULL,												NULL}
};
sw_command_t sh_nolac_if[] = {
	{"add_port",			2,	NULL,		cmd_nolac_add_port,	RUN,	"ADI Add interface to the Link Aggregation system",		NULL},
	{NULL,					0,	NULL,		NULL,			0,			NULL,												NULL}
};
//==========================================config_if.c END==================================================================================

















